using FluentValidation;
using CMSMicroservice.Protobuf.Protos.OtpToken;
namespace CMSMicroservice.Protobuf.Validator.OtpToken;

public class VerifyOtpTokenRequestValidator : AbstractValidator<VerifyOtpTokenRequest>
{
    public VerifyOtpTokenRequestValidator()
    {
        RuleFor(model => model.Mobile)
            .NotEmpty();
        RuleFor(model => model.Purpose)
            .NotEmpty();
        RuleFor(model => model.Code)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<VerifyOtpTokenRequest>.CreateWithOptions((VerifyOtpTokenRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
